tigase.xmpp.impl

## Class JabberIqRegister

- java.lang.Object
- - tigase.xmpp.XMPPProcessor
  - - tigase.xmpp.impl.JabberIqRegister

- All Implemented Interfaces:
    Comparable<XMPPImplIfc>, Initializable, RegistrarBean, UnregisterAware, XMPPImplIfc, XMPPProcessorConcurrencyAwareIfc, XMPPProcessorIfc

      @Bean(name="jabber:iq:register",
            parent=SessionManager.class,
            active=true)
      public class JabberIqRegister
      extends XMPPProcessor
      implements XMPPProcessorIfc, Initializable, UnregisterAware, RegistrarBean

  JEP-0077: In-Band Registration
  Created: Thu Feb 16 13:14:06 2006
  Version:
    $Rev$
  Author:
    Artur Hefczyc

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static interface` | `JabberIqRegister.AccountValidator`
    `static class` | `JabberIqRegister.CIDRAddress` As in http://commons.apache.org/proper/commons-net/jacoco/org.apache.commons .net.util/SubnetUtils.java.html
    `static class` | `JabberIqRegister.UserRegisteredEvent`
    `static class` | `JabberIqRegister.WelcomeMessageChangedEvent`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `ID`
    `static String` | `OAUTH_CONSUMERKEY_PROP_KEY` OAuth details for form verifier.
    `static String` | `OAUTH_CONSUMERSECRET_PROP_KEY`
    `static String` | `REGISTRATION_BLACKLIST_PROP_KEY`
    `static String` | `REGISTRATION_PER_SECOND_PROP_KEY`
    `static String` | `REGISTRATION_WHITELIST_PROP_KEY`
    `static String` | `SIGNED_FORM_REQUIRED_PROP_KEY`
    `static String` | `WHITELIST_REGISTRATION_ONLY_PROP_KEY`

    - ### Fields inherited from class tigase.xmpp.XMPPProcessor

      `ALL_NAMES, ALL_PATHS, cmpInfo`

    - ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

      `CLIENT_XMLNS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JabberIqRegister()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `beforeUnregister()` Method called before bean unregister.
    `protected void` | `createAccount(XMPPResourceConnection session, String user_name, VHostItem domain, String password, String email, Map<String,String> reg_params)`
    `protected void` | `doGetRegistrationForm(Packet packet, Element request, XMPPResourceConnection session, Queue<Packet> results)`
    `protected void` | `doRemoveAccount(Packet packet, Element request, XMPPResourceConnection session, Queue<Packet> results)`
    `LinkedList<String>` | `getRegistrationBlacklist()`
    `long` | `getRegistrationsPerSecond()`
    `LinkedList<String>` | `getRegistrationWhitelist()`
    `void` | `getStatistics(StatisticsList list)` The method allows to retrieve plugin own statistics if it generates any.
    `String` | `id()` Method `id` returns a unique ID of the plugin.
    `void` | `initialize()` Method will be called, when bean will be created, configured and ready to use.
    `protected boolean` | `isRegistrationAllowedForConnection(JID from)`
    `boolean` | `isSignedFormRequired()`
    `protected boolean` | `isTokenInBucket(JID from)`
    `void` | `onWelcomeMessageChange(JabberIqRegister.WelcomeMessageChangedEvent event)`
    `void` | `process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)` TODO: Implement registration form configurable and loading all the fields from the registration form TODO: rewrite the plugin using the XMPPProcessorAbstract API
    `void` | `register(Kernel kernel)` Method called when bean is being registered allowing developer to programatically register other beans.
    `void` | `setOAuthCredentials(String oauthConsumerKey, String oauthConsumerSecret)`
    `void` | `setRegistrationBlacklist(LinkedList<String> vals)`
    `void` | `setRegistrationsPerSecond(long registrationsPerSecond)`
    `void` | `setRegistrationWhitelist(LinkedList<String> vals)`
    `void` | `setSignedFormRequired(boolean required)`
    `void` | `setWelcomeMessage(String message)`
    `Element[]` | `supDiscoFeatures(XMPPResourceConnection session)` Method `supDiscoFeatures` returns an array of XML `Element`s with service discovery features which have to be returned to the client uppon request.
    `String[][]` | `supElementNamePaths()` Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin.
    `String[]` | `supNamespaces()` Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin.
    `Element[]` | `supStreamFeatures(XMPPResourceConnection session)` Method `supStreamFeatures` returns an array of XML `Element`s with stream features which have to be returned to the client uppon request.
    `void` | `unregister(Kernel kernel)` Method called while bean is being unregistered.

    - ### Methods inherited from class tigase.xmpp.XMPPProcessor

      `canHandle, compareTo, concurrentThreadsPerQueue, getComponentInfo, getInstance, getQueueSize, getThreadsNo, init, isSupporting, supElements, supTypes, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

      `canHandle, concurrentQueuesNo, concurrentThreadsPerQueue, getComponentInfo, init, isSupporting, supElements, supTypes`

    - ### Methods inherited from interface java.lang.Comparable

      `compareTo`

- - ### Field Detail

    - #### ID

          public static final String ID

      See Also:
        Constant Field Values

    - #### REGISTRATION_PER_SECOND_PROP_KEY

          public static final String REGISTRATION_PER_SECOND_PROP_KEY

      See Also:
        Constant Field Values

    - #### REGISTRATION_BLACKLIST_PROP_KEY

          public static final String REGISTRATION_BLACKLIST_PROP_KEY

      See Also:
        Constant Field Values

    - #### REGISTRATION_WHITELIST_PROP_KEY

          public static final String REGISTRATION_WHITELIST_PROP_KEY

      See Also:
        Constant Field Values

    - #### WHITELIST_REGISTRATION_ONLY_PROP_KEY

          public static final String WHITELIST_REGISTRATION_ONLY_PROP_KEY

      See Also:
        Constant Field Values

    - #### OAUTH_CONSUMERKEY_PROP_KEY

          public static final String OAUTH_CONSUMERKEY_PROP_KEY

      OAuth details for form verifier.
      See Also:
        Constant Field Values

    - #### OAUTH_CONSUMERSECRET_PROP_KEY

          public static final String OAUTH_CONSUMERSECRET_PROP_KEY

      See Also:
        Constant Field Values

    - #### SIGNED_FORM_REQUIRED_PROP_KEY

          public static final String SIGNED_FORM_REQUIRED_PROP_KEY

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### JabberIqRegister

          public JabberIqRegister()

  - ### Method Detail

    - #### getRegistrationsPerSecond

          public long getRegistrationsPerSecond()

    - #### setRegistrationsPerSecond

          public void setRegistrationsPerSecond(long registrationsPerSecond)

    - #### getRegistrationBlacklist

          public LinkedList<String> getRegistrationBlacklist()

    - #### setRegistrationBlacklist

          public void setRegistrationBlacklist(LinkedList<String> vals)

    - #### getRegistrationWhitelist

          public LinkedList<String> getRegistrationWhitelist()

    - #### setRegistrationWhitelist

          public void setRegistrationWhitelist(LinkedList<String> vals)

    - #### beforeUnregister

          public void beforeUnregister()

      Description copied from interface: `UnregisterAware`
      Method called before bean unregister.
      Specified by:
        `beforeUnregister` in interface `UnregisterAware`

    - #### register

          public void register(Kernel kernel)

      Description copied from interface: `RegistrarBean`
      Method called when bean is being registered allowing developer to programatically register other beans.
      Specified by:
        `register` in interface `RegistrarBean`
      Parameters:
        `kernel` - - instance from local scope

    - #### unregister

          public void unregister(Kernel kernel)

      Description copied from interface: `RegistrarBean`
      Method called while bean is being unregistered.
      Specified by:
        `unregister` in interface `RegistrarBean`
      Parameters:
        `kernel` - - instance from local scope

    - #### getStatistics

          public void getStatistics(StatisticsList list)

      Description copied from interface: `XMPPImplIfc`
      The method allows to retrieve plugin own statistics if it generates any.
      Specified by:
        `getStatistics` in interface `XMPPImplIfc`
      Overrides:
        `getStatistics` in class `XMPPProcessor`
      Parameters:
        `list` - is a statistics collection to which plugins own metrics can be added.

    - #### id

          public String id()

      Description copied from interface: `XMPPImplIfc`
      Method `id` returns a unique ID of the plugin. Each plugin has own, unique ID which is used in the configuration file to determine whether it needs to be loaded or not. In most cases the ID can be equal to XMLNS of the packages processed by the plugin.
      Specified by:
        `id` in interface `XMPPImplIfc`
      Returns:
        a `String` value

    - #### initialize

          public void initialize()

      Description copied from interface: `Initializable`
      Method will be called, when bean will be created, configured and ready to use.
      Specified by:
        `initialize` in interface `Initializable`

    - #### isSignedFormRequired

          public boolean isSignedFormRequired()

    - #### setSignedFormRequired

          public void setSignedFormRequired(boolean required)

    - #### onWelcomeMessageChange

          @HandleEvent
          public void onWelcomeMessageChange(JabberIqRegister.WelcomeMessageChangedEvent event)

    - #### process

          public void process(Packet packet,
                              XMPPResourceConnection session,
                              NonAuthUserRepository repo,
                              Queue<Packet> results,
                              Map<String,Object> settings)
                       throws XMPPException

      TODO: Implement registration form configurable and loading all the fields from the registration form TODO: rewrite the plugin using the XMPPProcessorAbstract API
      Specified by:
        `process` in interface `XMPPProcessorIfc`
      Parameters:
        `packet` - packet is which being processed. This parameter may never be null. Even though this is not immutable object it mustn't be altered. None of it's fields or attributes can be changed during processing.
        `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
        `repo` - this is a user data storage which is normally used when the user session (parameter above) is null. This is repository allows for a very restricted access only. It allows for storing some user private data (doesn't allow overwriting existing data) like messages for offline users and it also allows for reading user public data like VCard.
        `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
        `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.
      Throws:
        `XMPPException`

    - #### setOAuthCredentials

          public void setOAuthCredentials(String oauthConsumerKey,
                                          String oauthConsumerSecret)

    - #### setWelcomeMessage

          public void setWelcomeMessage(String message)
                                 throws TigaseDBException

      Throws:
        `TigaseDBException`

    - #### supDiscoFeatures

          public Element[] supDiscoFeatures(XMPPResourceConnection session)

      Description copied from interface: `XMPPImplIfc`
      Method `supDiscoFeatures` returns an array of XML `Element`s with service discovery features which have to be returned to the client uppon request. Service discovery features returned by this method correspond to services supported by this plugin.
      Specified by:
        `supDiscoFeatures` in interface `XMPPImplIfc`
      Overrides:
        `supDiscoFeatures` in class `XMPPProcessor`
      Parameters:
        `session` - a `XMPPResourceConnection` value
      Returns:
        an `Element[]` value

    - #### supElementNamePaths

          public String[][] supElementNamePaths()

      Description copied from interface: `XMPPImplIfc`
      Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin. Each element name path corresponds to XMLNS returned in array by `supNamespaces()` method. The element path itself is represented by a String array with each path element as a separate String.
      Specified by:
        `supElementNamePaths` in interface `XMPPImplIfc`
      Overrides:
        `supElementNamePaths` in class `XMPPProcessor`
      Returns:
        a `String[][]` value is an array for element paths for which the plugin offers processing capabilities. Each path is in form of a String array in order to reduce parsing overhead.

    - #### supNamespaces

          public String[] supNamespaces()

      Description copied from interface: `XMPPImplIfc`
      Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin. Each namespace corresponds to element name returned in array by `supElemenets()` method.
      Specified by:
        `supNamespaces` in interface `XMPPImplIfc`
      Overrides:
        `supNamespaces` in class `XMPPProcessor`
      Returns:
        a `String[]` value

    - #### supStreamFeatures

          public Element[] supStreamFeatures(XMPPResourceConnection session)

      Description copied from interface: `XMPPImplIfc`
      Method `supStreamFeatures` returns an array of XML `Element`s with stream features which have to be returned to the client uppon request. Stream features returned by this method correspond to features supported by this plugin.
      Specified by:
        `supStreamFeatures` in interface `XMPPImplIfc`
      Overrides:
        `supStreamFeatures` in class `XMPPProcessor`
      Parameters:
        `session` - a `XMPPResourceConnection` value
      Returns:
        an `Element[]` value

    - #### createAccount

          protected void createAccount(XMPPResourceConnection session,
                                       String user_name,
                                       VHostItem domain,
                                       String password,
                                       String email,
                                       Map<String,String> reg_params)
                                throws XMPPProcessorException,
                                       TigaseStringprepException,
                                       TigaseDBException

      Throws:
        `XMPPProcessorException`
        `TigaseStringprepException`
        `TigaseDBException`

    - #### doGetRegistrationForm

          protected void doGetRegistrationForm(Packet packet,
                                               Element request,
                                               XMPPResourceConnection session,
                                               Queue<Packet> results)
                                        throws XMPPProcessorException,
                                               NoConnectionIdException

      Throws:
        `XMPPProcessorException`
        `NoConnectionIdException`

    - #### doRemoveAccount

          protected void doRemoveAccount(Packet packet,
                                         Element request,
                                         XMPPResourceConnection session,
                                         Queue<Packet> results)
                                  throws XMPPProcessorException,
                                         NoConnectionIdException,
                                         PacketErrorTypeException,
                                         NotAuthorizedException,
                                         TigaseStringprepException,
                                         TigaseDBException

      Throws:
        `XMPPProcessorException`
        `NoConnectionIdException`
        `PacketErrorTypeException`
        `NotAuthorizedException`
        `TigaseStringprepException`
        `TigaseDBException`

    - #### isRegistrationAllowedForConnection

          protected boolean isRegistrationAllowedForConnection(JID from)

    - #### isTokenInBucket

          protected boolean isTokenInBucket(JID from)

Copyright © 2004–2019 "Tigase, Inc.". All rights reserved.